# MySQL dump 8.13
#
# Host: localhost    Database: planworld
#--------------------------------------------------------
# Server version	3.23.36

#
# Table structure for table 'Nodes'
#

CREATE TABLE Nodes (
  Name char(64) NOT NULL default '',
  Hostname char(128) NOT NULL default '',
  Path char(128) NOT NULL default '',
  Port int(10) unsigned NOT NULL default '80',
  PRIMARY KEY (Name)
) TYPE=MyISAM;

#
# Table structure for table 'Online'
#

CREATE TABLE Online (
  UserID int(10) UNSIGNED NOT NULL,
  Login int(10) UNSIGNED NOT NULL,
  LastAccess int(10) UNSIGNED NOT NULL,
  What char(64) NOT NULL default '',
  PRIMARY KEY (UserID),
  KEY Login (Login),
  KEY LastAccess (LastAccess)
) TYPE=MyISAM;

#
# Table structure for table 'Preferences'
#

CREATE TABLE Preferences (
  UserID int unsigned NOT NULL,
  Name char(255) NOT NULL default '',
  Value char(255) NOT NULL default '',
  PRIMARY KEY (UserID, Name)
) TYPE=MyISAM;

#
# Table structure for table 'Themes'
#

CREATE TABLE Themes (
  ID int(10) unsigned NOT NULL auto_increment,
  SkinID int(10) unsigned NOT NULL default '0',
  Name char(128) NOT NULL default '',
  Dir char(16) NOT NULL default '',
  AuthorName char(255) NOT NULL default '',
  AuthorContact char(64) NOT NULL default '',
  PRIMARY KEY  (ID),
  KEY SkinID (SkinID)
) TYPE=MyISAM;
				

#
# Table structure for table 'cookies'
#

CREATE TABLE cookies (
  cookieId int(12) NOT NULL auto_increment,
  quote text NOT NULL,
  author varchar(255) NOT NULL,
  submittedBy varchar(32) default NULL,
  PRIMARY KEY  (cookieId)
) TYPE=MyISAM;

#
# Table structure for table 'globalstats'
#

CREATE TABLE globalstats (
  totalhits bigint(20) unsigned NOT NULL default '0'
) TYPE=MyISAM;

#
# Table structure for table 'groups'
#

CREATE TABLE groups (
  id int(10) unsigned NOT NULL auto_increment,
  groupName char(32) NOT NULL default '',
  PRIMARY KEY  (id)
) TYPE=MyISAM;

#
# Table structure for table 'news'
#

CREATE TABLE news (
  newsId int(11) NOT NULL auto_increment,
  news text NOT NULL,
  date int(11) NOT NULL default '0',
  PRIMARY KEY  (newsId),
  UNIQUE KEY newsId (newsId)
) TYPE=MyISAM;

#
# Table structure for table 'plan'
#

CREATE TABLE plan (
  id int(10) unsigned NOT NULL auto_increment,
  userId int(10) unsigned NOT NULL default '0',
  planText text,
  PRIMARY KEY  (userId),
  UNIQUE KEY id (id)
) TYPE=MyISAM;

#
# Table structure for table 'planwatch'
#

CREATE TABLE planwatch (
  userId int(10) unsigned NOT NULL default '0',
  watchId int(10) unsigned NOT NULL default '0',
  lastView int(11) NOT NULL default '0',
  groupId int(10) unsigned default NULL,
  PRIMARY KEY (userId, watchId)
) TYPE=MyISAM;

#
# Table structure for table 'snitch'
#

CREATE TABLE snitch (
  userId int(10) unsigned NOT NULL default '0',
  snitchedBy char(32) NOT NULL default '',
  snitchDate int(11) NOT NULL default '0',
  snitchTimes int(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (userId,snitchedBy)
) TYPE=MyISAM;

#
# Table structure for table 'snoop'
#

CREATE TABLE snoop (
  userID int(10) unsigned NOT NULL default '0',
  snoopedBy char(32) NOT NULL default '',
  snoopDate int(11) NOT NULL default '0',
  PRIMARY KEY  (userID,snoopedBy)
) TYPE=MyISAM;

#
# Table structure for table 'users'
#

CREATE TABLE users (
  id int(10) unsigned NOT NULL auto_increment,
  username char(128) NOT NULL default '',
  remote enum('N','Y') NOT NULL default 'N',
  world enum('Y','N') NOT NULL default 'Y',
  snitch enum('N','Y') NOT NULL default 'N',
  snitchViews int(10) unsigned NOT NULL default '25',
  archive enum('P','N','Y') NOT NULL default 'P',
  totalViews int(11) NOT NULL default '0',
  watchOrder enum('alph','old','newest') default 'alph',
  themeID int(11) unsigned NOT NULL default '1',
  snitchOn int(11) NOT NULL default '0',
  lastOn int(11) NOT NULL default '0',
  lastUpdate int(11) NOT NULL default '0',
  PRIMARY KEY  (id),
  KEY username (username)
) TYPE=MyISAM;

