<?php
/**
 * $Id: index.php,v 1.9.2.1 2001/11/10 21:50:58 seth Exp $
 * XML-RPC back-end.
 * This consists of xml-rpc wrappers for functions to allow remote apps the
 * ability to make calls on the local system.  See xmlrpc.org for more
 * details.
 */

require_once('XML/RPC.php');
require_once('XML/RPC/Server.php');
$dir = getcwd();
chdir('..');
require_once('./config.php');
require_once('./functions.php');
require_once('./snitch.php');
require_once('./stats.php');
chdir($dir);

function xmlrpc_getText ($params) {
  // XXX check for false response
  connectToDatabase();
  if (is_string($params->params[0]->scalarval())) {
    if (isUser(addslashes($params->params[0]->scalarval()))) {
    	$uid = getIdFromName(addslashes($params->params[0]->scalarval()));
    } else {
	return new XML_RPC_Response(new XML_RPC_Value('', 'base64'));
    }
  } else {
    $uid = &$params->params[0]->scalarval();
  }

  if (getWorld($uid) == 'N') {
      return new XML_RPC_Response(new XML_RPC_Value('[This user\'s plan is not available]', 'base64'));
  }

  if ($params->params[2]->scalarval()) {
	addSnitchView($params->params[1]->scalarval(), $uid);
  }

  list($text) = getPlanText($uid);
  return new XML_RPC_Response(new XML_RPC_Value($text, 'base64'));
}

function xmlrpc_getID ($params) {
  connectToDatabase();
  return new XML_RPC_Response(new XML_RPC_Value(getIdFromName($params->params[0]->scalarval()), 'int'));
}

function xmlrpc_getLastLogin ($params) {
  // XXX check for false response
  connectToDatabase();

  if ($params->params[0]->kindOf() == 'array' || $params->params[0]->kindOf() == 'struct') {
    return new XML_RPC_Response(XML_RPC_encode(getLastLogin(XML_RPC_decode($params->params[0]))));
  } else if (is_int($params->params[0]->scalarval())) {
    return new XML_RPC_Response(new XML_RPC_Value(getLastLogin($params->params[0]->scalarval()), 'int'));
  } else if (is_string($params->params[0]->scalarval())) {
    return new XML_RPC_Response(new XML_RPC_Value(getLastLogin(getIdFromName($params->params[0]->scalarval())), 'int'));
  }
}

function xmlrpc_getLastUpdate ($params) {
  // XXX check for false response
  connectToDatabase();

  if ($params->params[0]->kindOf() == 'array' || $params->params[0]->kindOf() == 'struct') {
    return new XML_RPC_Response(XML_RPC_encode(getLastUpdated(XML_RPC_decode($params->params[0]))));
  } else if (is_int($params->params[0]->scalarval())) {
    return new XML_RPC_Response(new XML_RPC_Value(getLastUpdated($params->params[0]->scalarval()), 'int'));
  } else if (is_string($params->params[0]->scalarval())) {
    return new XML_RPC_Response(new XML_RPC_Value(getLastUpdated(getIdFromName($params->params[0]->scalarval())), 'int'));
  }
}

function xmlrpc_getNodes ($params) {
  global $dbh;
  connectToDatabase();
  $SQL = "SELECT Name, Hostname, Path, Port FROM Nodes ORDER BY Name";
  $result = mysql_query($SQL, $dbh);
  while ($row = mysql_fetch_array($result, MYSQL_ASSOC)) {
	$ret[] = array('Name' => $row['Name'],
				   'Hostname' => $row['Hostname'],
				   'Path' => $row['Path'],
				   'Port' => (int) $row['Port']);
  }
  return new XML_RPC_Response(XML_RPC_encode($ret));
}

function xmlrpc_getNumUsers ($p) {
  connectToDatabase();
  if ($p->params[0]->scalarval() == 'all') {
	return new XML_RPC_Response(new XML_RPC_Value(getNumPlanners(), 'int'));
  } else if ($p->params[0]->scalarval() == 'login') {
	if ($p->params[1]) {	
	  return new XML_RPC_Response(new XML_RPC_Value(getNumHaveLoggedIn($p->params[1]->scalarval()), 'int'));
	} else {
	  return new XML_RPC_Response(new XML_RPC_Value(getNumHaveLoggedIn(), 'int'));
	}
  }
}

function xmlrpc_getNumPlans ($p) {
  connectToDatabase();
  if ($p->params[0]) {	
	return new XML_RPC_Response(new XML_RPC_Value(getNumNew($p->params[0]->scalarval()), 'int'));
  } else {
	return new XML_RPC_Response(new XML_RPC_Value(getNumPlans(), 'int'));
  }
}

function xmlrpc_getNumViews ($p) {
  connectToDatabase();
  return new XML_RPC_Response(new XML_RPC_Value(getTotalPlanViews(), 'int'));
}

function xmlrpc_getNumHits ($p) {
  connectToDatabase();
  return new XML_RPC_Response(new XML_RPC_Value(getNumHits(), 'int'));
}

function xmlrpc_getNumSnitchRegistered ($p) {
  connectToDatabase();
  return new XML_RPC_Response(new XML_RPC_Value(getNumSnitchRegistered(), 'int'));
}

function xmlrpc_addSnoopReference ($p) {
  global $dbh;
  connectToDatabase();
  if (!$uid = getIdFromName($p->params[0]->scalarval())) {
      return new XML_RPC_Response(new XML_RPC_Value(false, 'boolean'));
  }
  if (!$sbid = getIdFromName($p->params[1]->scalarval())) {
	$sbid = addUser($p->params[0]->scalarval());
  }
  $SQL = "INSERT INTO snoop (userID, snoopedBy, snoopDate) VALUES ('{$uid}', '{$sbid}', UNIX_TIMESTAMP(NOW()))";
  mysql_query($SQL, $dbh);
  return new XML_RPC_Response(new XML_RPC_Value(true, 'boolean'));
}

function xmlrpc_removeSnoopReference ($p) {
    global $dbh;
    connectToDatabase();
    if (!$uid = getIdFromName($p->params[0]->scalarval())) {
      return new XML_RPC_Response(new XML_RPC_Value(false, 'boolean'));
    }
    $sbid = getIdFromName($p->params[1]->scalarval());
    $SQL = "DELETE FROM snoop WHERE UserID='{$uid}' AND snoopedBy='{$sbid}'";
    mysql_query($SQL, $dbh);
    return new XML_RPC_Response(new XML_RPC_Value(true, 'boolean'));
}

function xmlrpc_whois ($p) {
  global $dbh;
  connectToDatabase();
  return new XML_RPC_Response(XML_RPC_encode(getAllUsers($p->params[0]->scalarval())));
}

function xmlrpc_online ($p) {
  return new XML_RPC_Response(new XML_RPC_Value());
}

if (defined('PW_WORLD_ENABLE')) {
  // don't allow other sites to access if world-enabling is off
  $s = new XML_RPC_Server(array('plan.getText' => array('function' => 'xmlrpc_getText'),
								'users.getID' => array('function' => 'xmlrpc_getID'),
								'users.getLastLogin' => array('function' => 'xmlrpc_getLastLogin'),
								'users.getLastUpdate' => array('function' => 'xmlrpc_getLastUpdate'),
								'nodes.getNodes' => array('function' => 'xmlrpc_getNodes'),
  								'stats.getNumUsers' => array('function' => 'xmlrpc_getNumUsers'),
								'stats.getNumPlans' => array('function' => 'xmlrpc_getNumPlans'),
								'stats.getNumSnitchRegistered' => array('function' => 'xmlrpc_getNumSnitchRegistered'),
								'stats.getNumViews' => array('function' => 'xmlrpc_getNumViews'),
								'stats.getNumHits' => array('function' => 'xmlrpc_getNumHits'),
								'snoop.addReference' => array('function' => 'xmlrpc_addSnoopReference'),
                                'snoop.removeReference' => array('function' => 'xmlrpc_removeSnoopReference'),
                                'planworld.online' => array('function' => 'xmlrpc_online'),
                                'planworld.whois' => array('function' => 'xmlrpc_whois')));
}
?>
