<!-- $Id: faq.inc,v 1.11 2001/08/07 03:02:14 seth Exp $ -->
<span class="subtitle">Frequently Asked Questions</span>
<br />

<p><a name="welcome"></a>Welcome to planWorld! We hope to address most of your major
concerns with this brief FAQ.  If after reading this help section,
your questions or concerns persist, don't hesitate to
<a href="<?php echo PW_EMAIL; ?>">email us</a>.</p>

<p><a name="plans"></a><i><u>What is a plan? Why should I have
one?</u></i><br /> Plans serve as a sort of online bulletin board for
students, alumni, and faculty of Amherst College.  Most users use
plans as a place for quotes, life updates, or world domination
strategies.  Feel free to post whatever you like on your plan, just
remember that anyone can view it.  Read the <a href="?id=about"
title="About">about</a> page for more information about plans and
their history.</p>

<p><a name="offcampus"></a><i><u>Can I use planWorld off
campus?</u></i><br /> planWorld can be accessed from any computer that
has an internet connection and a web browser; whether you're in
Amherst, at home, or studying abroad in Scotland.</p>

<p><a name="nonamherst"></a><i><u>Can non-Amherst persons access
planWorld?</u></i><br /> At present, planWorld is only accessible to
users with active NT or alumni accounts.</p>

<?php
if (defined('PW_SNITCH_ENABLE')) {
?>
<p><a name="snitch"></a><u><i>What is</i> <strong>snitch</strong> <i>
and how does it work?</i></u><br /> A little known function carried over
from VAX, <i>snitch</i> allows you to view a list of users that have
viewed your plan (if those users also have <i>snitch</i> enabled), and
vice-versa.  However, disabling <i>snitch</i> clears all past entries;
thus you can't turn it on quickly and turn it off.</p>
<?php
}  // if (defined('PW_SNITCH_ENABLE'))
?>

<?php
if (defined('PW_SNOOP_ENABLE')) {
?>
<p><a name="snoop"></a><u><i>What is</i> <strong>snoop</strong> <i>and
how does it work?</i></u><br /> <i>Snoop</i> is the natural complement
to <i>snitch</i>.  Where <i>snitch</i> allows one to see who has been
reading their plan, <i>snoop</i> provides the means to see who has
been referencing yours.  The combination of the two allows for easier
conversing through plans (although this does not mean that plans
cannot and should not be used for anything else you may choose).</p>
<?php
}  // if (defined('PW_SNOOP_ENABLE'))
?>

<p><a name="themes"></a><u><i>Can I create my own planWorld</i> <strong>theme</strong><i>?</i></u>
<br /> 

You can!  You need to create a style sheet that follows our rules
and submit it to your local planworld administrator or <a
href="mailto:planworld-themes@note.amherst.edu">planworld-themes@note.amherst.edu</a>.
Probably, the best way to come up with a theme is look at the style
sheets we've got by saving some planWorld pages as plain HTML and
messing around with colors and fonts and stuff to make it look how you
want it to look.  Before you submit the theme you should read Baker
Franke's <a
href="http://note.amherst.edu/~befranke/themes/themesDoc.html">ThemesDoc.html</a> to make sure you have everything you
need.  All themes are subject to administrative approval (come on, we
can't just throw any old theme up there) but we encourage any and all
to submit suggested themes so that we can make planWorld look
snazzy.</p>

<p><a name="colors"></a><i><u>How do I insert images, colors, etc. into my plan?</u></i><br />
We're not going to spell it out for you; that's all part of the fun...
but check out these pages for some info...<br />
<ul>
<li><a href="http://htmlprimer.com/">HTML Primer</a></li>
<li><a href="http://www.amherst.edu/~wwjarnag/">Web Design Resource Site</a></li>
</ul></p>

<p><a name="disappear"></a><i><u>Why do HTML tags keep disappearing
from my plan?</u></i><br />
We try to be as inclusive as we can with allowed tags, but it's likely
that we've missed some.  If you believe we have, please email the <a
href="mailto:planworld@note.amherst.edu">Planworld development
team</a>.  In cases such as JavaScript, we have chosen to disallow
certain tags as we feel that they accelerate entropy in the community.
If none of these appears to be the problem, check your plan for
matching tags and quotation marks.</p>
