<?php
/**
 * $Id: prefs.inc,v 1.13 2001/10/07 17:53:36 seth Exp $
 * Preferences page.
 */

$watch_order = getWatchOrder($planworld_id);

switch($err) {
case '0':
  $error_message = "<p class=\"error\">Your preferences have been changed.</p>\n";
  break;
default:
  break;
}

if (defined('PW_THEME_ENABLE')) {
  // XXX change the 1 to a defined skin ID
  $themes = getThemeList('1');
  $curr_theme = getTheme($planworld_id);
}

if (defined('PW_SNITCH_ENABLE')) {
  $snitch = getSnitch($planworld_id);
  $snitchviews = getSnitchNum($planworld_id);

  switch ($snitch) {
   case 'Y':
     $snitch_on = ' checked="checked"';
     break;
   default:
     $snitch_off = ' checked="checked"';
     break;
  }

  switch ($snitchviews) {
   case '10':
     $sv_10 = ' selected="selected"';
     break;
   case '25':
     $sv_25 = ' selected="selected"';
    break;
   case '50':
     $sv_50 = ' selected="selected"';
     break;
   case '100':
     $sv_100 = ' selected="selected"';
     break;
   case '250':
     $sv_250 = ' selected="selected"';
     break;
   default:
     $sv_all = ' selected="selected"';
     break;
  }
}

if (defined('PW_WORLD_ENABLE')) {
  $world = getWorld($planworld_id);
  switch ($world) {
   case 'Y':
     $world_on = ' checked="checked"';
     break;
   default:
     $world_off = ' checked="checked"';
     break;
  }
}

switch ($watch_order) {
case 'newest':
  $watch_new = ' checked="checked"';
  break;
case 'old':
  $watch_old = ' checked="checked"';
  break;
default:
  $watch_alph = ' checked="checked"';
  break;
}

if (defined('PW_ARCHIVE_ENABLE')) {
  $archive = getArchive($planworld_id);
  switch ($archive) {
   case 'Y':
     $archive_on = ' checked="checked"';
     break;
   case 'N':
     $archive_off = ' checked="checked"';
   default:
     $archive_pvt = ' checked="checked"';
     break;
  }
}
?>
                  <span class="subtitle">Preferences</span><br />
                  <?php echo $error_message; ?>
                  <p>To change preferences, click on the desired boxes and select Update.  All changes can be made with only one update.</p>
                  <form method="get" action="update.php">
                  <div align="center"><input class="inputButton" type="submit" value="Update" /></div><br />
                  <table cellspacing="0" cellpadding="0" border="0">
                    <tr>
                      <td class="border">
                        <table width="100%" cellpadding="3" cellspacing="1" border="0">
<?php
if (defined('PW_SNITCH_ENABLE')) {
?>
<!-- Snitch -->
                          <tr>
                            <td colspan="3" align="left" class="columnheader">Snitch</td>
                          </tr>
                          <tr>
                            <td align="right" class="entry">
                              Enable:
                            </td>
                            <td align="left" class="entry">
                              <input class="inputRadio" type="radio" name="snitch" value="Y"<?php echo $snitch_on; ?> />
                            </td>
                            <td rowspan="2" valign="top" class="description">
                              <p><strong>Snitch</strong> enables you to see who has viewed your plan (though you can only see others who have snitch on as well). Disabling Snitch will also clear all past Snitch data.</p>
                            </td>
                          </tr>
                          <tr>
                            <td align="right" class="entry">
                              Disable:
                            </td>
                            <td align="left" class="entry">
                              <input class="inputRadio" type="radio" name="snitch" value="N"<?php echo $snitch_off; ?>>
                            </td>
                          </tr>

                          <tr>
                            <td colspan="2" align="center" class="entry">
                              <select name="snitchviews">
                                <option value="10"<?php echo $sv_10; ?>>10</option>
                                <option value="25"<?php echo $sv_25; ?>>25</option>
                                <option value="50"<?php echo $sv_50; ?>>50</option>
                                <option value="100"<?php echo $sv_100; ?>>100</option>
                                <option value="250"<?php echo $sv_250; ?>>250</option>
                                <option value=""<?php echo $sv_all; ?>>all</option>
                              </select>
                            </td>
                            <td valign="top" class="description">
                              <p>This determines how many snitch entries appear when you check to see who has viewed your plan.</p>
                            </td>
                          </tr>
<?php
}  // if (defined('PW_SNITCH_ENABLE')) {
if (defined('PW_ARCHIVE_ENABLE')) {
?>
<!-- Archiving -->
                          <tr>
                            <td colspan="3" align="left" class="columnheader">Archiving</td>
                          </tr>
                          <tr>
                            <td align="right" class="entry">
                              Private:
                            </td>
                            <td align="left" class="entry">
                              <input class="inputRadio" type="radio" name="archive" value="P"<?php echo $archive_pvt; ?> />
                            </td>
                            <td rowspan="3" valign="top" class="description">
                              <p>If <strong>Archiving</strong> is set to either <i>Public</i> or <i>Private</i>, old plans will be archived. <i>Public</i> archiving means that the general public will be able to view your old, archived plans. <i>Private</i> archiving means that you are the only one who can view your old plans. If you wish to clear your archives, first <i>Disable</i> archiving and then re-enable it with your preferred setting.</p>
                            </td>
                          </tr>
                          <tr>
                            <td align="right" class="entry">
                              Public:
                            </td>
                            <td align="left" class="entry">
                              <input class="inputRadio" type="radio" name="archive" value="Y"<?php echo $archive_on; ?> />
                            </td>
                          </tr>
                          <tr>
                            <td align="right" class="entry">
                              Disabled:
                            </td>
                            <td align="left" class="entry">
                              <input class="inputRadio" type="radio" name="archive" value="N"<?php echo $archive_off; ?> />
                            </td>
                          </tr>
<?php
} // if (defined('PW_ARCHIVE_ENABLE'))
if (defined('PW_THEME_ENABLE')) {
?>
<!-- Look and Feel -->
                          <tr>
                            <td colspan="3" align="left" class="columnheader">Look and Feel</td>
                          </tr>
                          <tr>
                            <td align="left" class="entry" colspan="2">
                              Theme:
                            </td>
                            <td valign="top" class="description" rowspan="2">
                              <p><strong>Themes</strong> determine how planWorld looks for <i>you</i>.  Themes generally change the color scheme, although other aspects may be affected.</p>
                            </td>
                          </tr>
                          <tr>
                            <td class="entry" colspan="2">
                              <select name="theme">
<?php
  if (is_array($themes)) {
    foreach ($themes as $t) {
?>
                                <option value="<?php echo $t['ID']; ?>"<?php if ($curr_theme == $t['ID']) echo ' selected'; ?>><?php echo $t['Name']; ?></option>
<?php
    } // foreach ($themes as $t)
  } // if (is_array($themes))
?>
                              </select>
                            </td>
                          </tr>
<?php
}  // if (defined('PW_THEME_ENABLE'))
?>
<!-- Watch Order -->
                          <tr>
                            <td colspan="3" align="left" class="columnheader">
                              Watch Order
                            </td>
                          </tr>
                          <tr>
                            <td align="right" class="entry">
                              Alph.:
                            </td>
                            <td align="left" class="entry">
                              <input class="inputRadio" type="radio" name="watchOrder" value="alph"<?php echo $watch_alph; ?> />
                            </td>
                            <td rowspan="3" class="description" valign="top">
                              <p><strong>Watch Order</strong> determines the order in which your planWatch will be displayed. <i>Alph.</i> orders entries alphabetically, by username.  <i>Recent</i> orders entries with the most recently updated on the top.  <i>Old</i> orders entries with the least recently updated on the top.</p>
                            </td>
                          </tr>
                          <tr>
                            <td align="right" class="entry">
                              Recent:
                            </td>
                            <td align="left" class="entry">
                              <input class="inputRadio" type="radio" name="watchOrder" value="newest"<?php echo $watch_new; ?> />
                            </td>
                          </tr>
                          <tr>
                            <td align="right" class="entry">
                              Old:
                            </td>
                            <td align="left" class="entry">
                              <input class="inputRadio" type="radio" name="watchOrder" value="old"<?php echo $watch_old; ?> />
                            </td>
                          </tr>
<?php
if (defined('PW_WORLD_ENABLE')) {
?>
<!-- World Viewable -->
                          <tr>
                            <td colspan="3" align="left" class="columnheader">World Viewable</td>
                          </tr>
                          <tr>
                            <td align="right" class="entry">
                              Enable:
                            </td>
                            <td align="left" class="entry">
                              <input class="inputRadio" type="radio" name="world" value="Y"<?php echo $world_on; ?> />
                            </td>
                            <td rowspan=2 valign=top class="description">
                              <p>If your plan is <strong>World Viewable</strong>, non-Amherst users will be able to view your plan using a finger gateway. E.g. <a href="http://www.amherst.edu/cgi-bin/finger?tgerety@note.amherst.edu" title="Finger tgerety" target="_blank">tgerety's planWorld plan</a>.</p>
                            </td>
                          </tr>
                          <tr>
                            <td align="right" class="entry">
                              Disable:
                            </td>
                            <td align="left" class="entry">
                              <input class="inputRadio" type="radio" name="world" value="N"<?php echo $world_off; ?> />
                            </td>
                          </tr>
<?php
}  // if (defined('PW_THEME_ENABLE'))
?>
                        </table>
                      </td>
                    </tr>
                  </table>
                  <br />
                  <div align="center"><input class="inputButton" type="submit" value="Update" /></div>
                  </form>
