<?php

/**
 * $Id: snitch.php,v 1.19 2001/07/02 18:33:48 seth Exp $
 * Snitch functions.
 * @author Alex Hochron <anhochron@amherst.edu>
 * @author Seth Fitzsimmons <seth@note.amherst.edu>
 */

function snitchCheck ($id, $target) {
  if (!defined('PW_SNITCH_ENABLE'))
    return false;
  // check to see if both users have snitch on and update if need be
  global $dbh;
  
  if ((getSnitch($id) == 'Y') && (getSnitch($target) == 'Y') && $id != $target) {
	addSnitchView($id, $target);
	return true;
  }

  return false;
}

function addSnitchView ($uid, $tid) {
  if (!defined('PW_SNITCH_ENABLE'))
	return false;

  global $dbh;

  if (is_string($uid)) {
	if (!isUser($uid)) {
	  $uid = addUser($uid);
	} else {
	  $uid = getIdFromName($uid);
	}
  }

  // check for current snitch entry
  $SQL = "SELECT snitchTimes FROM snitch WHERE userId='{$tid}' AND snitchedBy='{$uid}'";
  $result = mysql_query($SQL, $dbh);
  $row = mysql_fetch_array($result, MYSQL_ASSOC);
  
  if ($row) {  // a db entry already exists; update
	$SQL = "UPDATE snitch SET snitchDate=UNIX_TIMESTAMP(NOW()), snitchTimes='" . ($row['snitchTimes'] + 1) . "' WHERE userId='{$tid}' AND snitchedBy='{$uid}'";
  } else { // no db entry exists.  Create and assign.
	$SQL = "INSERT INTO snitch (userId, snitchedBy, snitchDate, snitchTimes) VALUES ('{$tid}', '{$uid}', UNIX_TIMESTAMP(NOW()), '1')";
  }
  
  mysql_query($SQL, $dbh);
  return true;
}

function getSnitchViews ($user, $show='', $order='d', $dir='d') {
  if (!defined('PW_SNITCH_ENABLE'))
    return false;
  global $dbh;

  if (getSnitch($user) == 'N')
	return -1;

  // get all data
  $SQL = "SELECT snitch.snitchedBy, snitch.snitchDate, snitch.snitchTimes, u2.username as snitchedByName, u2.lastUpdate FROM snitch, users LEFT JOIN users as u2 ON snitch.snitchedBy=u2.id WHERE snitch.userId='{$user}' AND users.id='{$user}' AND snitch.snitchDate > users.snitchOn AND snitch.snitchTimes > 0 ORDER BY ";
  switch ($order) {
  case 'u':
	$SQL .= "u2.username ";
	break;
  case 'v':
	$SQL .= "snitch.snitchTimes ";
	break;
  default:
	$SQL .= "snitch.snitchDate ";
	break;
  }

  if ($dir == 'a') {
	$SQL .= "ASC";
  } else {
	$SQL .= "DESC";
  }

  if (!empty($show)) {
	$SQL .= " LIMIT {$show}";
  }
  $result = mysql_query($SQL, $dbh);

  if (mysql_num_rows($result) == 0) {
	return false;
  } else { // set-up table, then show snitch results
	while ($row = mysql_fetch_array($result, MYSQL_ASSOC)) {
	  $return[] = array('ID' => (int) $row['snitchedBy'],
                        'Name' => $row['snitchedByName'],
						'Date' => (int) $row['snitchDate'],
						'Views' => (int) $row['snitchTimes'],
						'LastUpdate' => (int) $row['lastUpdate'],
						'InPlanwatch' => (boolean) inPlanwatch($user, (int) $row['snitchedBy']));  // this could / should be optimized
	}
  }

  return $return;
}

?>